/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

int A = 0;
/*@ ensures \at(A,Post) == 3; */
void __gen_e_acsl_f(void);

void f(void)
{
  int __gen_e_acsl_at_4;
  int __gen_e_acsl_at_3;
  int __gen_e_acsl_at_2;
  int __gen_e_acsl_at;
  __gen_e_acsl_at_3 = A;
  __gen_e_acsl_at = A;
  A = 1;
  F: {
       __gen_e_acsl_at_4 = __gen_e_acsl_at_3;
       __gen_e_acsl_at_2 = A;
       A = 2;
     }
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\at(A,Pre)",0,
                                 __gen_e_acsl_at);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\at(A,Pre) == 0";
    __gen_e_acsl_assert_data.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data.fct = "f";
    __gen_e_acsl_assert_data.line = 12;
    __e_acsl_assert(__gen_e_acsl_at == 0,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \at(A,Pre) == 0; */ ;
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,"\\at(A,F)",0,
                                 __gen_e_acsl_at_2);
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "Assertion";
    __gen_e_acsl_assert_data_2.pred_txt = "\\at(A,F) == 1";
    __gen_e_acsl_assert_data_2.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data_2.fct = "f";
    __gen_e_acsl_assert_data_2.line = 13;
    __e_acsl_assert(__gen_e_acsl_at_2 == 1,& __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
  }
  /*@ assert \at(A,F) == 1; */ ;
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_3 =
      {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,"A",0,A);
    __gen_e_acsl_assert_data_3.blocking = 1;
    __gen_e_acsl_assert_data_3.kind = "Assertion";
    __gen_e_acsl_assert_data_3.pred_txt = "\\at(A,Here) == 2";
    __gen_e_acsl_assert_data_3.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data_3.fct = "f";
    __gen_e_acsl_assert_data_3.line = 14;
    __e_acsl_assert(A == 2,& __gen_e_acsl_assert_data_3);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_3);
  }
  /*@ assert \at(A,Here) == 2; */ ;
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_4 =
      {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,
                                 "\\at(\\at(A,Pre),F)",0,__gen_e_acsl_at_4);
    __gen_e_acsl_assert_data_4.blocking = 1;
    __gen_e_acsl_assert_data_4.kind = "Assertion";
    __gen_e_acsl_assert_data_4.pred_txt = "\\at(\\at(A,Pre),F) == 0";
    __gen_e_acsl_assert_data_4.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data_4.fct = "f";
    __gen_e_acsl_assert_data_4.line = 15;
    __e_acsl_assert(__gen_e_acsl_at_4 == 0,& __gen_e_acsl_assert_data_4);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_4);
  }
  /*@ assert \at(\at(A,Pre),F) == 0; */ ;
  A = 3;
  return;
}

void g(int *p, int *q)
{
  int __gen_e_acsl_at_3;
  int __gen_e_acsl_at_2;
  int __gen_e_acsl_at;
  __e_acsl_store_block((void *)(& q),(size_t)8);
  __e_acsl_store_block((void *)(& p),(size_t)8);
  __e_acsl_initialize((void *)p,sizeof(int));
  *p = 0;
  __e_acsl_initialize((void *)(p + 1),sizeof(int));
  *(p + 1) = 1;
  __e_acsl_initialize((void *)q,sizeof(int));
  *q = 0;
  L1:
  {
    {
      int __gen_e_acsl_valid_read_3;
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_5 =
        {.values = (void *)0};
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_5,"q",
                                   (void *)q);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_5,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_read_3 = __e_acsl_valid_read((void *)q,sizeof(int),
                                                      (void *)q,
                                                      (void *)(& q));
      __gen_e_acsl_assert_data_5.blocking = 1;
      __gen_e_acsl_assert_data_5.kind = "RTE";
      __gen_e_acsl_assert_data_5.pred_txt = "mem_access: \\valid_read(q)";
      __gen_e_acsl_assert_data_5.file = "tests/arith/at.i";
      __gen_e_acsl_assert_data_5.fct = "g";
      __gen_e_acsl_assert_data_5.line = 31;
      __e_acsl_assert(__gen_e_acsl_valid_read_3,& __gen_e_acsl_assert_data_5);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_5);
      __gen_e_acsl_at_3 = *q;
    }
    {
      int __gen_e_acsl_valid_read;
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
        {.values = (void *)0};
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"q",
                                   (void *)q);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_read = __e_acsl_valid_read((void *)q,sizeof(int),
                                                    (void *)q,(void *)(& q));
      __gen_e_acsl_assert_data_2.blocking = 1;
      __gen_e_acsl_assert_data_2.kind = "RTE";
      __gen_e_acsl_assert_data_2.pred_txt = "mem_access: \\valid_read(q)";
      __gen_e_acsl_assert_data_2.file = "tests/arith/at.i";
      __gen_e_acsl_assert_data_2.fct = "g";
      __gen_e_acsl_assert_data_2.line = 29;
      __e_acsl_assert(__gen_e_acsl_valid_read,& __gen_e_acsl_assert_data_2);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
      __gen_e_acsl_at = *q;
    }
    __e_acsl_initialize((void *)p,sizeof(int));
    *p = 2;
  }
  __e_acsl_initialize((void *)(p + 1),sizeof(int));
  *(p + 1) = 3;
  __e_acsl_initialize((void *)q,sizeof(int));
  *q = 1;
  L2:
  {
    {
      int __gen_e_acsl_valid_read_2;
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_3 =
        {.values = (void *)0};
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"p",
                                   (void *)p);
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                   "__gen_e_acsl_at",0,__gen_e_acsl_at);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                     "sizeof(int)",0,sizeof(int));
      __gen_e_acsl_valid_read_2 = __e_acsl_valid_read((void *)(p + __gen_e_acsl_at),
                                                      sizeof(int),(void *)p,
                                                      (void *)(& p));
      __gen_e_acsl_assert_data_3.blocking = 1;
      __gen_e_acsl_assert_data_3.kind = "RTE";
      __gen_e_acsl_assert_data_3.pred_txt = "mem_access: \\valid_read(p + __gen_e_acsl_at)";
      __gen_e_acsl_assert_data_3.file = "tests/arith/at.i";
      __gen_e_acsl_assert_data_3.fct = "g";
      __gen_e_acsl_assert_data_3.line = 29;
      __e_acsl_assert(__gen_e_acsl_valid_read_2,& __gen_e_acsl_assert_data_3);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_3);
      __gen_e_acsl_at_2 = *(p + __gen_e_acsl_at);
    }
    A = 4;
  }
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\at(*(p + \\at(*q,__invalid_label)),L2)",
                                 0,__gen_e_acsl_at_2);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\at(*(p + \\at(*q,__invalid_label)),L2) == 2";
    __gen_e_acsl_assert_data.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data.fct = "g";
    __gen_e_acsl_assert_data.line = 29;
    __e_acsl_assert(__gen_e_acsl_at_2 == 2,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \at(*(p + \at(*q,__invalid_label)),L2) == 2; */ ;
  L3:
  /*@ assert \at(*(p + \at(*q,__invalid_label)),Here) == 2; */
  {
    int __gen_e_acsl_valid_read_4;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_4 =
      {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,
                                 "*(p + \\at(*q,__invalid_label))",0,
                                 *(p + __gen_e_acsl_at_3));
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_6 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_6,"p",(void *)p);
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_6,
                                 "__gen_e_acsl_at_3",0,__gen_e_acsl_at_3);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_6,
                                   "sizeof(int)",0,sizeof(int));
    __gen_e_acsl_valid_read_4 = __e_acsl_valid_read((void *)(p + __gen_e_acsl_at_3),
                                                    sizeof(int),(void *)p,
                                                    (void *)(& p));
    __gen_e_acsl_assert_data_6.blocking = 1;
    __gen_e_acsl_assert_data_6.kind = "RTE";
    __gen_e_acsl_assert_data_6.pred_txt = "mem_access: \\valid_read(p + __gen_e_acsl_at_3)";
    __gen_e_acsl_assert_data_6.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data_6.fct = "g";
    __gen_e_acsl_assert_data_6.line = 31;
    __e_acsl_assert(__gen_e_acsl_valid_read_4,& __gen_e_acsl_assert_data_6);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_6);
    __gen_e_acsl_assert_data_4.blocking = 1;
    __gen_e_acsl_assert_data_4.kind = "Assertion";
    __gen_e_acsl_assert_data_4.pred_txt = "\\at(*(p + \\at(*q,__invalid_label)),Here) == 2";
    __gen_e_acsl_assert_data_4.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data_4.fct = "g";
    __gen_e_acsl_assert_data_4.line = 31;
    __e_acsl_assert(*(p + __gen_e_acsl_at_3) == 2,
                    & __gen_e_acsl_assert_data_4);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_4);
  }
  __e_acsl_delete_block((void *)(& q));
  __e_acsl_delete_block((void *)(& p));
  return;
}

/*@ ensures \result == \old(x); */
int __gen_e_acsl_h(int x);

int h(int x)
{
  __e_acsl_store_block((void *)(& x),(size_t)4);
  __e_acsl_delete_block((void *)(& x));
  return x;
}

int main(void)
{
  long __gen_e_acsl_at_3;
  long __gen_e_acsl_at_2;
  int __gen_e_acsl_at;
  int __retres;
  int x;
  int t[2];
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  __e_acsl_store_block((void *)(t),(size_t)8);
  __e_acsl_store_block((void *)(& x),(size_t)4);
  __e_acsl_full_init((void *)(& x));
  x = __gen_e_acsl_h(0);
  L:
  /*@ assert x == 0; */
  {
    __gen_e_acsl_at_3 = (long)x;
    __gen_e_acsl_at_2 = x + 1L;
    __gen_e_acsl_at = x;
    {
      __e_acsl_assert_data_t __gen_e_acsl_assert_data =
        {.values = (void *)0};
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"x",0,x);
      __gen_e_acsl_assert_data.blocking = 1;
      __gen_e_acsl_assert_data.kind = "Assertion";
      __gen_e_acsl_assert_data.pred_txt = "x == 0";
      __gen_e_acsl_assert_data.file = "tests/arith/at.i";
      __gen_e_acsl_assert_data.fct = "main";
      __gen_e_acsl_assert_data.line = 48;
      __e_acsl_assert(x == 0,& __gen_e_acsl_assert_data);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
    }
  }
  __e_acsl_full_init((void *)(& x));
  x = 1;
  __e_acsl_full_init((void *)(& x));
  x = 2;
  __gen_e_acsl_f();
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                 "\\at(x,__invalid_label)",0,__gen_e_acsl_at);
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "Assertion";
    __gen_e_acsl_assert_data_2.pred_txt = "\\at(x,__invalid_label) == 0";
    __gen_e_acsl_assert_data_2.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data_2.fct = "main";
    __gen_e_acsl_assert_data_2.line = 54;
    __e_acsl_assert(__gen_e_acsl_at == 0,& __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
  }
  /*@ assert \at(x,__invalid_label) == 0; */ ;
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_3 =
      {.values = (void *)0};
    __e_acsl_assert_register_long(& __gen_e_acsl_assert_data_3,
                                  "\\at(x + 1,__invalid_label)",0,
                                  __gen_e_acsl_at_2);
    __gen_e_acsl_assert_data_3.blocking = 1;
    __gen_e_acsl_assert_data_3.kind = "Assertion";
    __gen_e_acsl_assert_data_3.pred_txt = "\\at(x + 1,__invalid_label) == 1";
    __gen_e_acsl_assert_data_3.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data_3.fct = "main";
    __gen_e_acsl_assert_data_3.line = 55;
    __e_acsl_assert(__gen_e_acsl_at_2 == 1L,& __gen_e_acsl_assert_data_3);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_3);
  }
  /*@ assert \at(x + 1,__invalid_label) == 1; */ ;
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_4 =
      {.values = (void *)0};
    __e_acsl_assert_register_long(& __gen_e_acsl_assert_data_4,
                                  "\\at(x,__invalid_label)",0,
                                  __gen_e_acsl_at_3);
    __gen_e_acsl_assert_data_4.blocking = 1;
    __gen_e_acsl_assert_data_4.kind = "Assertion";
    __gen_e_acsl_assert_data_4.pred_txt = "\\at(x,__invalid_label) + 1 == 1";
    __gen_e_acsl_assert_data_4.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data_4.fct = "main";
    __gen_e_acsl_assert_data_4.line = 56;
    __e_acsl_assert(__gen_e_acsl_at_3 + 1L == 1L,
                    & __gen_e_acsl_assert_data_4);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_4);
  }
  /*@ assert \at(x,__invalid_label) + 1 == 1; */ ;
  g(t,& x);
  __retres = 0;
  __e_acsl_delete_block((void *)(t));
  __e_acsl_delete_block((void *)(& x));
  __e_acsl_memory_clean();
  return __retres;
}

/*@ ensures \result == \old(x); */
int __gen_e_acsl_h(int x)
{
  int __gen_e_acsl_at;
  int __retres;
  __e_acsl_store_block((void *)(& __retres),(size_t)4);
  __e_acsl_store_block((void *)(& x),(size_t)4);
  __gen_e_acsl_at = x;
  __retres = h(x);
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\result",0,
                                 __retres);
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\old(x)",0,
                                 __gen_e_acsl_at);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Postcondition";
    __gen_e_acsl_assert_data.pred_txt = "\\result == \\old(x)";
    __gen_e_acsl_assert_data.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data.fct = "h";
    __gen_e_acsl_assert_data.line = 38;
    __e_acsl_assert(__retres == __gen_e_acsl_at,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
    __e_acsl_delete_block((void *)(& x));
    __e_acsl_delete_block((void *)(& __retres));
    return __retres;
  }
}

/*@ ensures \at(A,Post) == 3; */
void __gen_e_acsl_f(void)
{
  int __gen_e_acsl_at;
  f();
  {
    __gen_e_acsl_at = A;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\at(A,Post)",0,
                                 __gen_e_acsl_at);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Postcondition";
    __gen_e_acsl_assert_data.pred_txt = "\\at(A,Post) == 3";
    __gen_e_acsl_assert_data.file = "tests/arith/at.i";
    __gen_e_acsl_assert_data.fct = "f";
    __gen_e_acsl_assert_data.line = 7;
    __e_acsl_assert(__gen_e_acsl_at == 3,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
    return;
  }
}


